/* 
 * MyTask.c
 *
 * MicroC/OS uIP Adtion
 *
 * Lee Jae-Hong. http://www.pyrasis.com
 *
 */

#include "includes.h"
#include "uip.h"
#include "uip_arp.h"
#include "uipopt.h"
#include "httpd.h"
#include "telnet.h"
#include "ne2000.h"

/* ne2000 Ʈũ ī ü */
struct nic *ne2000;

#define BUF ((struct uip_eth_hdr *)&uip_buf[0])

#define	TASK_STK_SIZE 1024  /* Stack size, in bytes */
#define	N_TASKS 2           /* Number of tasks      */

OS_STK TaskStk[N_TASKS][TASK_STK_SIZE/sizeof(OS_STK)];  /* Tasks stacks */

/* Prototypes */
void  TaskStart (void *data);
void  Task1(void * pParam);
/* void  Task2(void * pParam); */
void  Sleep(INT16U uSec);
void  ClearScreen();
void  OnScreen(int x, int y, char *pszText, int nColor);

/* Application entry point, invoked from Entry.obj */

void main()
{
  int	LineNo10 = 10;
  int	LineNo11 = 20;
  
  /*  top ּ  */
  __asm	MOV	ESP,0A0000h;
  
  /* ȭ鿡 banner */
  ClearScreen();
  OnScreen(0, 0, "Welcome to Micro-C/OS-II on x86 in protected mode!", 14);
  
  /* uC/OS-II ʱȭ. */
  OSCpuInit();
  OSInit();

  ne2000_probe(ne2000);
  ne2000_reset(ne2000);

  uip_init();

  httpd_init();

  uip_setethaddr(ne2000);
  
  /* ΰ Task. */
  OSTaskCreate(Task1, (void *)&LineNo10, &TaskStk[0][TASK_STK_SIZE], 0);
  /* OSTaskCreate(Task2, (void *)&LineNo11, &TaskStk[1][TASK_STK_SIZE], 1); */

  /* Task. */
  OSStart();

  /* NEVER EXECUTED */
}

/* Display a line of characters at the line specified by the parameter,
 * assuming a color 80x25 video adapter.
 * 
 * This function never returns.
 */

/*
 * ȭ鿡 Ŀ ȸϴ  .
 */
void Task1(void *pParam)
{
  u8_t i, arptimer;
  char *string1, *string2;

  arptimer = 0;
  debug = 0;

  while (1) 
  {
    uip_len = ne2000_poll(ne2000);
    if(uip_len == 0) {
      for(i = 0; i < UIP_CONNS; i++) {
        /* debug = 1; */
        uip_periodic(i);
        sprintf(string1, "%d", debug);
        OnScreen(0, 7, string1, 14);
        /* 
         * ⼭ ý  (Bochs  realtime=0  ) 
         * ݱ : ARP Ŷ  . ARP Request Broadcast  .
         * PING Reply Ŷ ICMP üũ ߸Ǿ ° ذ.
         * ne2000.c tmpbuf uip_buf   ڿ   
         * üũ ߸  . 
         * ICMPŶ  .  ӵ  Ұ. PING ð 
         *  PING  . 
         */
        if(uip_len > 0) {
          uip_arp_out();
          ne2000_transmit(ne2000, BUF->dest.addr, HTONS(BUF->type), uip_len, uip_buf);
        }
      }

      if(++arptimer == 20) {
        uip_arp_timer();
        arptimer = 0;
      }
    
    } else {
      if(BUF->type == htons(UIP_ETHTYPE_IP)) {
        uip_arp_ipin();
        uip_input();
      
        if(uip_len > 0) {
          uip_arp_out();
          ne2000_transmit(ne2000, BUF->dest.addr, HTONS(BUF->type), uip_len, uip_buf);
        }
      
      } else if(BUF->type == htons(UIP_ETHTYPE_ARP)) {
        uip_arp_arpin();
        
        if(uip_len > 0) {
          ne2000_transmit(ne2000, BUF->dest.addr, HTONS(BUF->type), uip_len, uip_buf);
        }
      }
    }
    
    
    OSTimeDlyHMSM(0,0,0,50); /* time delay for 100ms */
  }
}

/*
 * ȭ鿡 ڸ īƮ Ŵ
 */
#if 0
void Task2(void *pParam)
{
  int LineNo = *(int *)pParam;
  int k = 4;
  
  while (1)
  {
    /* ClearScreen(); */
    if (k == 4)
      OnScreen(30, LineNo, "Under working 1", 14);
    else if (k == 3)
      OnScreen(30, LineNo, "Under working 2", 14);
    else if (k == 2)
      OnScreen(30, LineNo, "Under working 3", 14);
    else if (k == 1)
      OnScreen(30, LineNo, "Under working 4", 14);
    k--;
    if ( k == 0 ) k = 4;
    
    OSTimeDlyHMSM(0,0,0,50); /* time delay for 100ms */

    }
}
#endif

/*
 * Sleeps for the specified delay (in seconds).
 * Since the 8254 is not set in this implementation,
 * sleeping one second means sleeping 18 clock ticks.
 */
void Sleep(INT16U uSec)
{
  OSTimeDly((INT16U)(18 * uSec));
}

/* Clears the screen. */
void ClearScreen()
{
  int x, y;
  char *pScreen = (char *) 0xb8000;
  
  for (y = 0; y < 25; y++)
    for (x = 0; x < 80; x++)
    {
      *pScreen++ = ' ';
      *pScreen++ = 7;
    }
}

/* Displays a string on the screen, assuming a 80x25 color adapter. */
void OnScreen(int x, int y, char *pszText, int nColor)
{
  char *pScreen = (char *)(0xb8000 + y * 160 + x * 2);
  
  while (*pszText)
  {
    *pScreen++ = *pszText++;
    *pScreen++ = nColor;
  }
}

/*
 * STARTUP TASK
 */
void TaskStart (void *data)
{

}
/* $PAGE */
